Index: sandbox/workflow/trunk/inc/class.so_orgchart.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.so_orgchart.inc.php	(revision 2063)
+++ sandbox/workflow/trunk/inc/class.so_orgchart.inc.php	(revision 2372)
@@ -127,6 +127,6 @@
 		$this->isAdmin = $_SESSION['phpgw_info']['workflow']['user_is_admin'];
 		$this->acl = &$GLOBALS['ajax']->acl;
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBWorkflow()->Link_ID;
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBWorkflow()->Link_ID;
+		$this->db = &Factory::getInstance('WorkflowObjects')->getDBWorkflow()->Link_ID;
+		$this->db = &Factory::getInstance('WorkflowObjects')->getDBWorkflow()->Link_ID;
 		$this->db->SetFetchMode(ADODB_FETCH_ASSOC);
 	}
@@ -711,5 +711,5 @@
 
 		$output = $result->GetArray(-1);
-		$cachedLDAP = $GLOBALS['workflow']['factory']->newInstance('CachedLDAP');
+		$cachedLDAP = Factory::newInstance('CachedLDAP');
 		$cachedLDAP->setOperationMode($cachedLDAP->OPERATION_MODE_LDAP_DATABASE);
 		for ($i = 0; $i < count($output); $i++)
@@ -765,6 +765,6 @@
 
 		/* search for the $searchTerm in the LDAP */
-		$ldap = &$GLOBALS['workflow']['workflowObjects']->getLDAP();
-		$list = @ldap_search($ldap, $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getLDAPContext(), $ldapSearch, array('uidnumber', 'cn', 'uid'));
+		$ldap = &Factory::getInstance('WorkflowObjects')->getLDAP();
+		$list = @ldap_search($ldap, Factory::getInstance('WorkflowLDAP')->getLDAPContext(), $ldapSearch, array('uidnumber', 'cn', 'uid'));
 		if ($list === false)
 			die(serialize("O sistema de busca não pode ser utilizado nesta organização."));
@@ -774,5 +774,5 @@
 
 		/* search for the $searchTerm in the DB */
-		$resultSet = $GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID->query($DBSearch, $DBValues)->GetArray(-1);
+		$resultSet = Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID->query($DBSearch, $DBValues)->GetArray(-1);
 		foreach ($resultSet as $row)
 			if (!isset($unifiedResult[$row['uidnumber']]))
@@ -823,5 +823,5 @@
 		{
 			$errors = array(
-				"O funcionário \"" . $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($employeeID) . "\" já pertença à área \"{$row['sigla']}\".",
+				"O funcionário \"" . Factory::getInstance('WorkflowLDAP')->getName($employeeID) . "\" já pertença à área \"{$row['sigla']}\".",
 				'-----------------',
 				'Caso você queira colocá-lo na área selecionada, siga o procedimento: faça uma busca por seu nome, clique para editá-lo e, troque pela área desejada.'
@@ -881,5 +881,5 @@
 		{
 			$errors = array(
-				"O funcionário \"" . $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($employeeID) . "\" é titular, substituto, já participou de substituição ou é auxiliar administrativo das seguintes áreas: " . implode(", ", $areas),
+				"O funcionário \"" . Factory::getInstance('WorkflowLDAP')->getName($employeeID) . "\" é titular, substituto, já participou de substituição ou é auxiliar administrativo das seguintes áreas: " . implode(", ", $areas),
 				'-----------------',
 				'Se você quiser excluir este funcionário, precisa removê-lo dos "cargos" que ele possui nas áreas citadas.'
@@ -919,5 +919,5 @@
 		$this->_checkError($result);
 
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = &Factory::getInstance('WorkflowLDAP');
 		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
 		{
@@ -999,5 +999,5 @@
 			$query = 'SELECT 1 FROM funcionario WHERE (funcionario_id = ?)';
 			if (!$this->db->query($query, $checkEmployee)->fetchRow())
-				$errors[] = "O funcionário \"" . $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($checkEmployee) . "\" não está vinculado a uma área.";
+				$errors[] = "O funcionário \"" . Factory::getInstance('WorkflowLDAP')->getName($checkEmployee) . "\" não está vinculado a uma área.";
 		}
 
@@ -1044,5 +1044,5 @@
 			$query = 'SELECT 1 FROM funcionario WHERE (funcionario_id = ?)';
 			if (!$this->db->query($query, $checkEmployee)->fetchRow())
-				$errors[] = "O funcionário \"" . $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($checkEmployee) . "\" não está vinculado a uma área.";
+				$errors[] = "O funcionário \"" . Factory::getInstance('WorkflowLDAP')->getName($checkEmployee) . "\" não está vinculado a uma área.";
 		}
 
@@ -1091,4 +1091,9 @@
 		$this->_checkAccess($organizationID, false, true);
 
+		/**
+		 * This is so wrong.. We should always use the factory to
+		 * instantiate stuff. Besides, module class should not
+		 * use process classes; the correct is to do the inverse.
+		 */
 		require_once dirname(__FILE__) . '/local/classes/class.wf_orgchart.php';
 		$orgchart = new wf_orgchart();
@@ -1096,5 +1101,5 @@
 		$outputInfo = array();
 
-		$cachedLDAP = $GLOBALS['workflow']['factory']->newInstance('CachedLDAP');
+		$cachedLDAP = Factory::newInstance('CachedLDAP');
 
 		/* here we need fresh information. Let's access ldap first */
@@ -1262,5 +1267,5 @@
 		);
 
-		$cachedLDAP = $GLOBALS['workflow']['factory']->newInstance('CachedLDAP');
+		$cachedLDAP = Factory::newInstance('CachedLDAP');
 		$cachedLDAP->setOperationMode($cachedLDAP->OPERATION_MODE_LDAP_DATABASE);
 		if (!empty($areaInfo['titular_funcionario_id']))
@@ -1512,7 +1517,5 @@
 
 		/* we must query ldap to get full user names. In workflow db we just store uids */
-		$cachedLDAP = $GLOBALS['workflow']['factory']->newInstance('CachedLDAP');
-
-		$cachedLDAP->getEntryByID();
+		$cachedLDAP = Factory::getInstance('CachedLDAP');
 
 		$output = $result->GetArray(-1);
Index: sandbox/workflow/trunk/inc/class.so_adminaccess.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.so_adminaccess.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.so_adminaccess.inc.php	(revision 2372)
@@ -77,5 +77,5 @@
 	{
 		$output = array();
-		$names = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getNames($userIDs);
+		$names = Factory::getInstance('WorkflowLDAP')->getNames($userIDs);
 		foreach ($names as $name)
 			$output[] = array(
@@ -201,6 +201,6 @@
 		if (!is_object($GLOBALS['phpgw']->acl))
 		{
-			$GLOBALS['phpgw']->db = &$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
-			$GLOBALS['phpgw']->acl = &$GLOBALS['workflow']['factory']->getForeignInstance('phpgwapi', 'acl', $userID);
+			$GLOBALS['phpgw']->db =& Factory::getInstance('WorkflowObjects')->getDBExpresso();
+			$GLOBALS['phpgw']->acl =& Factory::getInstance('acl', $userID);
 		}
 
Index: sandbox/workflow/trunk/inc/class.bo_agent.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_agent.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_agent.inc.php	(revision 2372)
@@ -278,5 +278,5 @@
 			if (!(isset($this->process)))
 			{
-				$this->process = CreateObject('workflow.workflow_process');
+				$this->process = Factory::getInstance('workflow_process');
 				$this->process->getProcess($wf_p_id);
 			}
Index: sandbox/workflow/trunk/inc/class.bo_participants.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_participants.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_participants.inc.php	(revision 2372)
@@ -34,5 +34,5 @@
 	function bo_participants()
 	{
-		$this->ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$this->ldap = &Factory::getInstance('WorkflowLDAP');
 	}
 
Index: sandbox/workflow/trunk/inc/common.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/common.inc.php	(revision 1484)
+++ sandbox/workflow/trunk/inc/common.inc.php	(revision 2372)
@@ -1,29 +1,74 @@
 <?php
-if (file_exists(dirname(__FILE__) . '/../../header.session.inc.php')) {
-	require_once dirname(__FILE__) . '/../../header.session.inc.php';
+/**************************************************************************\
+* eGroupWare                                                               *
+* http://www.egroupware.org                                                *
+* --------------------------------------------                             *
+*  This program is free software; you can redistribute it and/or modify it *
+*  under the terms of the GNU General Public License as published by the   *
+*  Free Software Foundation; either version 2 of the License, or (at your  *
+*  option) any later version.                                              *
+\**************************************************************************/
+
+/**
+ * Server base path. This constant is somewhat simililar to
+ * 'PHPGW_SERVER_ROOT'. Nevertheless, there are cases that we
+ * access Workflow directly and it must be defined somewhere.
+ * Recently discovered, when we are runnnig jobs HTTP_SERVER_VARS
+ * exported by apache are not available.
+ * Therefore, we are using this workaround here, setting
+ * EGW_SERVER_ROOT based on the location of this file. This constant
+ * should be updated properly every time we move this file.
+ * @name EGW_SERVER_ROOT
+ */
+define('EGW_SERVER_ROOT', dirname(dirname(dirname(__FILE__))));
+//define('EGW_SERVER_ROOT', $GLOBALS['HTTP_SERVER_VARS']['DOCUMENT_ROOT']);
+
+/**
+ * Server include base path. We must define our own constants
+ * because there are several cases in which workflow is called
+ * directly, thus PHPGW constants are not defined.
+ * @name EGW_INC_ROOT
+ */
+define('EGW_INC_ROOT', EGW_SERVER_ROOT . '/phpgwapi/inc/');
+
+/**
+ * Workflow base path.
+ * @name WF_SERVER_ROOT
+ */
+define('WF_SERVER_ROOT', EGW_SERVER_ROOT.'/workflow/');
+
+/**
+ * Workflow include path.
+ * @name WF_INC_ROOT
+ */
+define('WF_INC_ROOT', WF_SERVER_ROOT.'/inc/');
+
+/**
+ * Workflow lib base dir.
+ * @name WF_LIB_ROOT
+ */
+define('WF_LIB_ROOT', WF_SERVER_ROOT.'/lib/');
+
+
+if (file_exists(EGW_SERVER_ROOT . '/header.session.inc.php')) {
+	require_once EGW_SERVER_ROOT . '/header.session.inc.php';
 }
 
-/* garante que durante a execução de funções que modificam strings, os
- * caracteres acentuados sejam tratados corretamente (e.g. strtoupper)
- */
+
+/* assure that the correct encondig will be used (e.g string functions) */
 setlocale(LC_CTYPE, 'pt_BR', 'pt_BR.iso-8859-1', 'pt_BR.utf-8');
+
 
 /* define o umask para a criação de arquivos por parte do Workflow */
 umask(007);
 
-require_once dirname(__FILE__) . '/class.factory.inc.php';
 
-/**
- * Objeto que implementa uma Factory
- * @global object $GLOBALS['workflow']['factory']
- * @name $factory
- */
-$GLOBALS['workflow']['factory'] = new Factory();
+/* including common classes */
+require_once WF_LIB_ROOT . 'security/Security.php';
+require_once WF_LIB_ROOT . 'factory/Factory.php';
+require_once WF_LIB_ROOT . 'factory/BaseFactory.php';
+require_once WF_LIB_ROOT . 'factory/WorkflowFactory.php';
+require_once WF_LIB_ROOT . 'factory/ProcessFactory.php';
 
-/**
- * Objeto que cria objetos voltados exclusivamente para o módulo Workflow
- * @global object $GLOBALS['workflow']['workflowObjects']
- * @name $workflowObjects
- */
-$GLOBALS['workflow']['workflowObjects'] = $GLOBALS['workflow']['factory']->newInstance('WorkflowObjects');
+$GLOBALS['workflow']['workflowObjects'] = Factory::getInstance('WorkflowObjects');
 ?>
Index: sandbox/workflow/trunk/inc/class.ui_adminroles.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_adminroles.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_adminroles.inc.php	(revision 2372)
@@ -42,5 +42,5 @@
 		parent::WorkflowUtils();
 
-		$this->workflow_acl = CreateObject('workflow.workflow_acl');
+		$this->workflow_acl = Factory::getInstance('workflow_acl');
 		$denyAccess = true;
 		if ($this->workflow_acl->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
@@ -71,7 +71,7 @@
 		}
 
-		$this->process_manager	= CreateObject('workflow.workflow_processmanager');
-		$this->activity_manager	= CreateObject('workflow.workflow_activitymanager');
-		$this->role_manager	= CreateObject('workflow.workflow_rolemanager');
+		$this->process_manager	= Factory::getInstance('workflow_processmanager');
+		$this->activity_manager	= Factory::getInstance('workflow_activitymanager');
+		$this->role_manager	= Factory::getInstance('workflow_rolemanager');
 		$this->form_action = $GLOBALS['phpgw']->link('/index.php', 'menuaction=workflow.ui_adminroles.form');
 		
@@ -254,8 +254,8 @@
 			$this->t->set_var('list_mappings', '<tr><td colspan="3" align="center">'. lang('There are no mappings defined for this process')  .'</td></tr>');
 		}
-		else {	
+		else {
 			/* load the LDAP information */
-			$cachedLDAP = $GLOBALS['workflow']['factory']->getInstance('CachedLDAP');
-			$tmpLDAP = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+			$cachedLDAP = Factory::getInstance('CachedLDAP');
+			$tmpLDAP = &Factory::getInstance('WorkflowLDAP');
 			$userContext  = $tmpLDAP->getUserContext();
 			$groupContext = $tmpLDAP->getGroupContext();
@@ -264,10 +264,10 @@
 			{
 				if ($mapping['wf_account_type'] == 'g') {
-					$sri = ldap_search($GLOBALS['workflow']['workflowObjects']->getLDAP(), 
-									$groupContext, 
+					$sri = ldap_search(Factory::getInstance('WorkflowObjects')->getLDAP(),
+									$groupContext,
 									'(&(gidnumber=' . (int)$mapping['wf_user'] . ')(phpgwAccountType=g))');
-									
-					$allValues = ldap_get_entries($GLOBALS['workflow']['workflowObjects']->getLDAP(), $sri);
-					
+
+					$allValues = ldap_get_entries(Factory::getInstance('WorkflowObjects')->getLDAP(), $sri);
+
 					$cname = $GLOBALS['phpgw']->translation->convert($allValues[0]['cn'][0],'utf-8');
 					$glabel = '[' . lang('Group') . ']';
@@ -280,5 +280,5 @@
 						$glabel = '<font color="red">(excluído)</font>';
 				}
-				
+
 				$this->t->set_var(array(
 					'map_user_id'	=> $mapping['wf_user'],
@@ -313,9 +313,9 @@
 	 * Show users roles selects
 	 * @param string $all_roles_data
-	 * @return 
+	 * @return
 	 */
 	function show_users_roles_selects($all_roles_data)
 	{
-		$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+		$templateServer = &Factory::getInstance('TemplateServer');
 		$imgaddusers = $templateServer->generateImageLink('add_group.png');
 		$imgdelusers = $templateServer->generateImageLink('delete_group.png');
@@ -325,5 +325,5 @@
 			'src_img_del_users' => $imgdelusers
 		));
-		
+
 		$this->t->set_block('admin_roles', 'block_select_roles', 'select_roles');
 		foreach ($all_roles_data as $role)
Index: sandbox/workflow/trunk/inc/class.WorkflowUtils.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.WorkflowUtils.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.WorkflowUtils.inc.php	(revision 2372)
@@ -1,3 +1,5 @@
 <?php
+	require_once 'common.inc.php';
+
 	//set here the global DEBUG level which is actually 0 (nothing) or 1 (all)
 	if (!defined('_DEBUG')) define('_DEBUG', 0);
@@ -102,10 +104,10 @@
 			$this->start		= (int)get_var('start', 'any', 0);
 			$this->search_str	= get_var('find', 'any', '');
-			$this->nextmatchs	= CreateObject('phpgwapi.nextmatchs');
+			$this->nextmatchs	= Factory::getInstance('nextmatchs');
 		}
 
 		/**
 		 * Fill the process bar
-		 * 
+		 *
 		 * @param array $proc_info
 		 * @access public
@@ -116,5 +118,5 @@
 			//echo "proc_info: <pre>";print_r($proc_info);echo "</pre>";
 			$this->t->set_file('proc_bar_tpl', 'proc_bar.tpl');
-			$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+			$templateServer = &Factory::getInstance('TemplateServer');
 
 			if ($proc_info['wf_is_valid'] == 'y')
@@ -170,5 +172,5 @@
 		/**
 		 * Select activity representation icon
-		 *  
+		 *
 		 * @var string $type type of activity
 		 * @var bool   $interactive interactive?
@@ -207,10 +209,10 @@
 					$ic="no-activity.gif";
 			}
-			return '<img src="'. $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateImageLink($ic) .'" alt="'. lang($type) .'" title="'. lang($type) .'" />';
-		}
-	
+			return '<img src="'. Factory::getInstance('TemplateServer')->generateImageLink($ic) .'" alt="'. lang($type) .'" title="'. lang($type) .'" />';
+		}
+
 		/**
 		 * Translate template file
-		 * @param string $template_name template name 
+		 * @param string $template_name template name
 		 * @return void
 		 * @access public
@@ -359,5 +361,5 @@
 		function export()
 		{
-			$this->process_manager	= CreateObject('workflow.workflow_processmanager');
+			$this->process_manager	= Factory::getInstance('workflow_processmanager');
 
 			// retrieve process info
@@ -387,12 +389,12 @@
 		{
 			$file = "css/$css_name" . (($print_mode !== false) ? '_print' : '') . '.css';
-			return $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->getWebFile($file);
-		}
-		
+			return Factory::getInstance('TemplateServer')->getWebFile($file);
+		}
+
 		/**
 		 * Return a given duration in human readable form, usefull for workitems duration
 		 * @param int $to given duration
 		 * @return string given duration in human readable form
-		 * @access public 
+		 * @access public
 		 */
 		function time_diff($to) {
Index: sandbox/workflow/trunk/inc/class.WorkflowMacro.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.WorkflowMacro.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.WorkflowMacro.inc.php	(revision 2372)
@@ -40,5 +40,5 @@
 		require dirname(__FILE__) . '/../setup/setup.inc.php'; /* DO NOT USE require_once */
 		$GLOBALS['phpgw_info']['apps']['workflow'] = $setup_info['workflow'];
-		$row = $GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID->query('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'files_dir'))->fetchRow();
+		$row = Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID->query('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'files_dir'))->fetchRow();
 		$_SESSION['phpgw_info']['workflow']['vfs_basedir'] = ($row !== false) ? $row['config_value'] : '/home/expressolivre';
 		$_SESSION['phpgw_info']['workflow']['phpgw_api_inc'] = PHPGW_API_INC;
@@ -48,7 +48,6 @@
 		require_once PHPGW_API_INC . '/functions.inc.php';
 		require_once 'engine/class.ajax_config.inc.php';
-		require_once 'engine/class.ajax_ldap.inc.php';
 		require_once 'engine/config.ajax.inc.php';
-		$GLOBALS['ajax']->ldap = new ajax_ldap();
+		$GLOBALS['ajax']->ldap = &Factory::getInstance('ajax_ldap');
 
 		/* definição de algumas constantes */
@@ -64,8 +63,7 @@
 	public function prepareProcessEnvironment($processID)
 	{
-		require_once GALAXIA_LIBRARY . '/src/common/WfRuntime.php';
 		require_once PHPGW_SERVER_ROOT . '/workflow/inc/local/functions/local.functions.php';
 
-		$runtime = new WfRuntime($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$runtime = &Factory::getInstance('WfRuntime', Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		$runtime->loadProcess($processID);
 
Index: sandbox/workflow/trunk/inc/class.workflow_instance.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_instance.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_instance.inc.php	(revision 2372)
@@ -6,6 +6,4 @@
 
 	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'API' . SEP . 'Instance.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'common' . SEP . 'WfSecurity.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php');
 	/**
 	 * @package Workflow
@@ -20,5 +18,5 @@
 		function workflow_Instance()
 		{
-			parent::Instance($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::Instance(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.external_bridge.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.external_bridge.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.external_bridge.inc.php	(revision 2372)
@@ -13,5 +13,4 @@
 require_once 'common.inc.php';
 require_once 'engine/config.egw.inc.php';
-require_once 'class.so_adminaccess.inc.php';
 
 /**
@@ -52,6 +51,6 @@
 	function external_bridge()
 	{
-		$this->db = $GLOBALS['workflow']['workflowObjects']->getDBGalaxia();
-		$this->acl = new so_adminaccess($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$this->db = Factory::getInstance('WorkflowObjects')->getDBGalaxia();
+		$this->acl = &Factory::getInstance('so_adminaccess', Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 	}
 	/**
@@ -156,5 +155,5 @@
 
 		/* assign variables to the template */
-		$smarty = $GLOBALS['workflow']['factory']->getInstance('workflow_smarty', false);
+		$smarty = Factory::getInstance('workflow_smarty', false);
 		$smarty->assign('encodedForm', $encodedForm);
 		$smarty->assign('siteAddress', $this->siteAddress);
Index: sandbox/workflow/trunk/inc/class.ui_participants.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_participants.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_participants.inc.php	(revision 2372)
@@ -41,5 +41,5 @@
 	function ui_participants()
 	{
-		$this->bo = $GLOBALS['workflow']['factory']->getInstance('bo_participants');
+		$this->bo = Factory::getInstance('bo_participants');
 	}
 
@@ -51,9 +51,9 @@
 	function form()
 	{
-		$smarty = $GLOBALS['workflow']['factory']->getInstance('workflow_smarty', false);
+		$smarty = Factory::getInstance('workflow_smarty', false);
 		$smarty->setHeader(workflow_smarty::SHOW_HEADER | workflow_smarty::SHOW_FOOTER);
-		$ldap = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = Factory::getInstance('WorkflowLDAP');
 		$userDN = $GLOBALS['phpgw_info']['user']['account_dn'];
-		$account = $GLOBALS['workflow']['factory']->getForeignInstance('phpgwapi', 'accounts', $userDN);
+		$account = Factory::getInstance('accounts', $userDN);
 		$organizationList = $this->bo->getOrganizations();
 
Index: sandbox/workflow/trunk/inc/class.so_userinterface.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.so_userinterface.inc.php	(revision 2094)
+++ sandbox/workflow/trunk/inc/class.so_userinterface.inc.php	(revision 2372)
@@ -1,4 +1,3 @@
 <?php
-require_once($_SESSION['phpgw_info']['workflow']['phpgw_api_inc'] . '/class.config.inc.php');
 
 /**
@@ -22,5 +21,5 @@
 	function so_userinterface()
 	{
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBWorkflow()->Link_ID;
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBWorkflow()->Link_ID;
 		$this->db->SetFetchMode(ADODB_FETCH_ASSOC);
 	}
@@ -61,5 +60,5 @@
 		$oldDB = $GLOBALS['phpgw']->db;
 		$GLOBALS['phpgw']->db = $GLOBALS['ajax']->db;
-		$config = new config('workflow');
+		$config = &Factory::getInstance('config', 'workflow');
 		$configValues = $config->read_repository();
 		$submasksString = $configValues['intranet_subnetworks'];
@@ -93,5 +92,5 @@
 		if (!empty($externalApplicationsID))
 		{
-			$result = $GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID->query("SELECT DISTINCT external_application_id, name, address, image, authentication, intranet_only FROM egw_wf_external_application WHERE (external_application_id IN (" . implode(', ', $externalApplicationsID)  . ")) ORDER BY name");
+			$result = Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID->query("SELECT DISTINCT external_application_id, name, address, image, authentication, intranet_only FROM egw_wf_external_application WHERE (external_application_id IN (" . implode(', ', $externalApplicationsID)  . ")) ORDER BY name");
 			$preOutput = $result->GetArray(-1);
 
@@ -245,5 +244,5 @@
 
 		$employees = $result->GetArray(-1);
-		$cachedLDAP = $GLOBALS['workflow']['factory']->newInstance('CachedLDAP');
+		$cachedLDAP = Factory::newInstance('CachedLDAP');
 		$cachedLDAP->setOperationMode($cachedLDAP->OPERATION_MODE_NORMAL);
 		$categoriesCount = array();
@@ -318,5 +317,5 @@
 
 		$employees = $result->GetArray(-1);
-		$cachedLDAP = $GLOBALS['workflow']['factory']->newInstance('CachedLDAP');
+		$cachedLDAP = Factory::newInstance('CachedLDAP');
 		$cachedLDAP->setOperationMode($cachedLDAP->OPERATION_MODE_NORMAL);
 		for ($i = 0; $i < count($employees); $i++)
@@ -370,5 +369,5 @@
 
 		/* searching employees by name in the ldap server */
-		$list = @ldap_search($ldap, $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getLDAPContext(), ('(&(cn=*' . $searchTerm . '*)(phpgwaccounttype=u))'), array('uidNumber', 'cn', 'telephoneNumber'));
+		$list = @ldap_search($ldap, Factory::getInstance('WorkflowLDAP')->getLDAPContext(), ('(&(cn=*' . $searchTerm . '*)(phpgwaccounttype=u))'), array('uidNumber', 'cn', 'telephoneNumber'));
 		if ($list === false)
 			return false;
@@ -466,5 +465,5 @@
 
 		/* executing it */
-		$list = @ldap_search($ldap, $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getLDAPContext(), $ldap_query, array('uidNumber', 'cn', 'telephoneNumber'));
+		$list = @ldap_search($ldap, Factory::getInstance('WorkflowLDAP')->getLDAPContext(), $ldap_query, array('uidNumber', 'cn', 'telephoneNumber'));
 		$entries = ldap_get_entries($ldap, $list);
 
@@ -475,5 +474,5 @@
 
 		/* we will need to search into database 'cache' for users deleted in ldap */
-		$cachedLDAP = $GLOBALS[ 'workflow' ][ 'factory' ] -> newInstance( 'CachedLDAP' );
+		$cachedLDAP = Factory::newInstance( 'CachedLDAP' );
 		$cachedLDAP -> setOperationMode( $cachedLDAP -> OPERATION_MODE_DATABASE );
 
@@ -531,5 +530,5 @@
 
 		/* searching employees by telephoneNumber in the ldap server */
-		$list = @ldap_search($ldap, $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getLDAPContext(), ('(&(telephoneNumber=*' . $searchTerm . '*)(phpgwaccounttype=u))'), array('uidNumber', 'cn', 'telephoneNumber'));
+		$list = @ldap_search($ldap, Factory::getInstance('WorkflowLDAP')->getLDAPContext(), ('(&(telephoneNumber=*' . $searchTerm . '*)(phpgwaccounttype=u))'), array('uidNumber', 'cn', 'telephoneNumber'));
 
 		if (!$list) return false;
@@ -594,7 +593,5 @@
 	function getEmployeeInfo($employeeID, $organizationID)
 	{
-		require_once dirname(__FILE__) . '/class.so_orgchart.inc.php';
-
-		$SOOrgchart = new so_orgchart();
+		$SOOrgchart = &Factory::getInstance('so_orgchart');
 		$SOOrgchart->setExternalCalls(true);
 		$output = $SOOrgchart->getEmployeeInfo($employeeID, $organizationID);
@@ -614,7 +611,5 @@
 	function getAreaInfo($areaID, $organizationID)
 	{
-		require_once dirname(__FILE__) . '/class.so_orgchart.inc.php';
-
-		$SOOrgchart = new so_orgchart();
+		$SOOrgchart = &Factory::getInstance('so_orgchart');
 		$SOOrgchart->setExternalCalls(true);
 		$output = $SOOrgchart->getAreaInfo($areaID, $organizationID);
@@ -652,5 +647,5 @@
 		$result = $this -> db -> query( "SELECT a.sigla as area, a.titular_funcionario_id as titular, s.funcionario_id as substituto, s.data_inicio, s.data_fim FROM area a INNER JOIN substituicao s ON ((a.area_id = s.area_id) AND (CURRENT_DATE BETWEEN s.data_inicio AND s.data_fim)) WHERE (organizacao_id = ?) ORDER BY area", array( $organizationID ) );
 
-		$cachedLDAP = $GLOBALS[ 'workflow' ][ 'factory' ] -> newInstance( 'CachedLDAP' );
+		$cachedLDAP = Factory::newInstance( 'CachedLDAP' );
 		$cachedLDAP -> setOperationMode( $cachedLDAP -> OPERATION_MODE_LDAP_DATABASE );
 
@@ -719,5 +714,5 @@
 
 		$employees = $result -> GetArray( -1 );
-		$cachedLDAP = $GLOBALS[ 'workflow' ][ 'factory' ] -> newInstance( 'CachedLDAP' );
+		$cachedLDAP = Factory::newInstance( 'CachedLDAP' );
 		$cachedLDAP -> setOperationMode( $cachedLDAP -> OPERATION_MODE_NORMAL );
 
@@ -791,5 +786,5 @@
 		$employees = $result -> GetArray( -1 );
 
-		$cachedLDAP = $GLOBALS[ 'workflow' ][ 'factory' ] -> newInstance( 'CachedLDAP' );
+		$cachedLDAP = Factory::newInstance( 'CachedLDAP' );
 		$cachedLDAP -> setOperationMode( $cachedLDAP -> OPERATION_MODE_NORMAL );
 
@@ -817,5 +812,5 @@
 		usort( $employees, create_function( '$a,$b', 'return strcasecmp($a[\'cn\'],$b[\'cn\']);' ) );
 
-		$paging = $GLOBALS['workflow']['factory']->newInstance('Paging', 50, $_POST);
+		$paging = Factory::newInstance('Paging', 50, $_POST);
 		$employees = $paging->restrictItems( $employees );
 
Index: sandbox/workflow/trunk/inc/class.WorkflowJobManager.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.WorkflowJobManager.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.WorkflowJobManager.inc.php	(revision 2372)
@@ -16,5 +16,5 @@
 	public function WorkflowJobManager()
 	{
-		parent::JobManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		parent::JobManager(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 	}
 }
